dnl aclocal.m4 generated automatically by aclocal 1.4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

dnl @synopsis BNV_HAVE_QT [--with-Qt-includes=DIR] [--with-Qt-dir=DIR]
dnl
dnl Search for Trolltech's Qt GUI framework.
dnl
dnl Searches common directories for Qt include files, libraries and the
dnl meta object compiler. If one of the options is given, the search is
dnl started in the given directory. If both options are given, no checks
dnl are performed and the cache is not consulted nor altered.
dnl
dnl The following shell variable is set to either "yes" or "no":
dnl
dnl   have_qt
dnl
dnl Additionally, the following variables are exported:
dnl
dnl   QT_CXXFLAGS
dnl   QT_LIBS
dnl   QT_MOC
dnl   QT_DIR
dnl
dnl which contain an "-I" flag pointing to the Qt include directory, link flags
dnl necessary to link with Qt and X, the name of the meta object compiler
dnl with full path, and the variable QTDIR as Trolltech likes to see it
dnl defined, respectively.
dnl
dnl Example lines for Makefile.in:
dnl
dnl   CXXFLAGS = @QT_CXXFLAGS@
dnl   MOC      = @QT_MOC@
dnl
dnl After the variables have been set, a trial compile and link is
dnl performed to check the correct functioning of the meta object compiler.
dnl If this test fails, a warning appears in the output of configure, but
dnl the variables remain defined.
dnl
dnl No common variables such as $LIBS or $CFLAGS are polluted.
dnl
dnl Options:
dnl
dnl --with-Qt-includes=DIR: DIR should point to where the Qt
dnl includes can be found, as in -IDIR.
dnl
dnl --with-Qt-dir=DIR: DIR should point to the "QTDIR", i.e.,
dnl libraries are in DIR/lib/.
dnl
dnl If at least one of the options "=no" or, equivalently,
dnl --without-Qt-includes and/or --without-Qt-dir is given, "have_qt" is set
dnl to "no" and the other variables are set to the empty string.
dnl
dnl Calls BNV_PATH_QT_DIRECT as a subroutine.
dnl
dnl @version $Id: acinclude.m4,v 1.1.1.1 2001/12/07 14:48:32 immi Exp $
dnl @author Bastiaan N. Veelo <Bastiaan.N.Veelo@immtek.ntnu.no>
dnl
dnl Some minor changes by Immanuel Herrmann (marked with -Immi)
dnl
AC_DEFUN([BNV_HAVE_QT],
[
  AC_REQUIRE([AC_PROG_CXX])
  AC_REQUIRE([AC_PATH_X])
  AC_REQUIRE([AC_PATH_XTRA])

  AC_MSG_CHECKING(for Qt)

  AC_ARG_WITH([Qt-includes],
    [  --with-Qt-includes=DIR  Qt include files are in DIR])
  AC_ARG_WITH([Qt-dir],
    [  --with-Qt-dir=DIR       Qt library file is in DIR/lib/])
  if test x"$with_Qt_includes" = x"no" || test x"$with_Qt_dir" = x"no"; then
    # user disabled Qt. Leave cache alone.
    have_qt="User disabled Qt."
  else
    # "yes" is a bogus option
    if test "x$with_Qt_includes" = xyes; then
      with_Qt_includes=
    fi
    if test "x$with_Qt_dir" = xyes; then
      with_Qt_dir=
    fi
    if test "x$with_Qt_includes" != x && test "x$with_Qt_dir" != x; then
      # Both values are set, no need to search
      have_qt=yes
      bnv_qt_includes="$with_Qt_includes"
      bnv_qt_dir="$with_Qt_dir"
      bnv_qt_LIBS="-lqt $X_PRE_LIBS $X_LIBS -lX11 -lXext -lXmu -lXt -lXi $X_EXTRA_LIBS"
      if test x"$with_Qt_dir" != x; then
        bnv_qt_LIBS="-L$with_Qt_dir/lib $bnv_qt_LIBS"
      fi
    else
      # Use cached value or do search, starting with suggestions from
      # the command line
      AC_CACHE_VAL(bnv_cv_have_qt,
      [
        # One or both of the vars are not set, and there is no cached value.
        bnv_qt_includes=NO bnv_qt_dir=NO
        BNV_PATH_QT_DIRECT
        if test "$bnv_qt_includes" = NO || test "$bnv_qt_dir" = NO; then
          # Didn't find Qt anywhere.  Cache the known absence of Qt.
          bnv_cv_have_qt="have_qt=no"
        else
          # Record where we found Qt for the cache.
          bnv_cv_have_qt="have_qt=yes              \
                  bnv_qt_includes=$bnv_qt_includes \
                       bnv_qt_dir=$bnv_qt_dir      \
                      bnv_qt_LIBS=\"$bnv_qt_LIBS\""
        fi
      ])dnl
      eval "$bnv_cv_have_qt"
    fi # all $bnv_qt_* are set
  fi   # $have_qt reflects the system status
  if test x"$have_qt" = xyes; then
    QT_CXXFLAGS="-I$bnv_qt_includes"
    QT_DIR="$bnv_qt_dir"
    QT_LIBS="$bnv_qt_LIBS"
    QT_MOC="$bnv_qt_dir/bin/moc"
    AC_MSG_RESULT([$have_qt:
    QT_CXXFLAGS=$QT_CXXFLAGS
    QT_LIBS=$QT_LIBS
    QT_MOC=$QT_MOC])
  else
    QT_CXXFLAGS=
    QT_DIR=
    QT_LIBS=
    QT_MOC=
    AC_MSG_RESULT($have_qt)
  fi
  # Put each AC_SUBST in its own line. (Otherwise, automake doesn't recognize
  # them.) -Immi
  AC_SUBST(QT_CXXFLAGS)
  AC_SUBST(QT_DIR)
  AC_SUBST(QT_LIBS)
  AC_SUBST(QT_MOC)

  #### Being paranoid:
  AC_MSG_CHECKING(the Qt meta object compiler)
  AC_CACHE_VAL(bnv_cv_qt_test_result,
  [
    cat > bnv_qt_test.h << EOF
#include <qobject.h>
class Test : public QObject
{
Q_OBJECT
public:
  Test() {}
  ~Test() {}
public slots:
  void receive() {}
signals:
  void send();
};
EOF

    cat > bnv_qt_main.$ac_ext << EOF
#include "bnv_qt_test.h"
#include <qapplication.h>
int main( int argc, char **argv )
{
  QApplication app( argc, argv );
  Test t;
  QObject::connect( &t, SIGNAL(send()), &t, SLOT(receive()) );
}
EOF

    bnv_cv_qt_test_result="failure"
    bnv_try_1="$QT_MOC bnv_qt_test.h -o moc_bnv_qt_test.$ac_ext >/dev/null 2>bnv_qt_test_1.out"
    AC_TRY_EVAL(bnv_try_1)
    bnv_err_1=`grep -v '^ *+' bnv_qt_test_1.out | grep -v "^bnv_qt_test.h\$"`
    if test -n "$bnv_err_1"; then
      echo "$bnv_err_1" >&AC_FD_CC
      echo "configure: could not run $QT_MOC on:" >&AC_FD_CC
      cat bnv_qt_test.h >&AC_FD_CC
    else
      bnv_try_2="$CXX $QT_CXXFLAGS -c $CXXFLAGS -o moc_bnv_qt_test.o moc_bnv_qt_test.$ac_ext >/dev/null 2>bnv_qt_test_2.out"
      AC_TRY_EVAL(bnv_try_2)
      bnv_err_2=`grep -v '^ *+' bnv_qt_test_2.out | grep -v "^bnv_qt_test.{$ac_ext}\$"`
      if test -n "$bnv_err_2"; then
        echo "$bnv_err_2" >&AC_FD_CC
        echo "configure: could not compile:" >&AC_FD_CC
        cat bnv_qt_test.$ac_ext >&AC_FD_CC
      else
        bnv_try_3="$CXX $QT_CXXFLAGS -c $CXXFLAGS -o bnv_qt_main.o bnv_qt_main.$ac_ext >/dev/null 2>bnv_qt_test_3.out"
        AC_TRY_EVAL(bnv_try_3)
        bnv_err_3=`grep -v '^ *+' bnv_qt_test_3.out | grep -v "^bnv_qt_main.{$ac_ext}\$"`
        if test -n "$bnv_err_3"; then
          echo "$bnv_err_3" >&AC_FD_CC
          echo "configure: could not compile:" >&AC_FD_CC
          cat bnv_qt_main.$ac_ext >&AC_FD_CC
        else
          bnv_try_4="$CXX $QT_LIBS $LIBS -o bnv_qt_main bnv_qt_main.o moc_bnv_qt_test.o >/dev/null 2>bnv_qt_test_4.out"
          AC_TRY_EVAL(bnv_try_4)
          bnv_err_4=`grep -v '^ *+' bnv_qt_test_4.out`
          if test -n "$bnv_err_4"; then
            echo "$bnv_err_4" >&AC_FD_CC
          else
            bnv_cv_qt_test_result="succes"
          fi
        fi
      fi
    fi
  ])dnl AC_CACHE_VAL bnv_cv_qt_test_result
  AC_MSG_RESULT([$bnv_cv_qt_test_result]);
  if test x"$bnv_cv_qt_test_result" = "xfailure"; then
    AC_MSG_WARN([Your Qt installation seems to be broken!])
  fi

  rm -f bnv_qt_test.h moc_bnv_qt_test.$ac_ext moc_bnv_qt_test.o \
        bnv_qt_main.$ac_ext bnv_qt_main.o bnv_qt_main \
        bnv_qt_test_1.out bnv_qt_test_2.out bnv_qt_test_3.out bnv_qt_test_4.out
])

dnl Internal subroutine of BNV_HAVE_QT
dnl Set bnv_qt_includes bnv_qt_dir.
dnl Copyright 2001 Bastiaan N. Veelo <Bastiaan.N.Veelo@immtek.ntnu.no>
AC_DEFUN(BNV_PATH_QT_DIRECT,
[
  ## Look for include files ##
  qt_direct_test_header=qapplication.h
  # First, try using that file with no special directory specified.
  AC_TRY_CPP([#include <$qt_direct_test_header>],
  [
    # Success.
    # We can compile using Qt headers with no special include directory.
    bnv_qt_includes=
  ], [
    # That did not work.
    echo "Non-critical error, please neglect the above." >&AC_FD_CC
    # Look for the header file in a standard set of common directories.
    # Added some paths:   -Immi
    bnv_include_path_list="
      $with_Qt_include
      /usr/include/qt
      /usr/lib/qt/include
      /usr/include
      /usr/X11R6/include/X11/qt
      /usr/X11R6/include/qt
      /usr/lib/qt2/include
      /usr/lib/qt1g/include
      `ls -d /usr/local/qt*/include 2>/dev/null`
    "
    for bnv_dir in $bnv_include_path_list; do
      if test -r "$bnv_dir/$qt_direct_test_header"; then
        bnv_qt_includes=$bnv_dir
        break
      fi
    done
  ])

  ## Look for Qt directory ##
  qt_direct_test_library=qt
  qt_direct_test_main="
    int argc;
    char ** argv;
    QApplication app(argc,argv);
  "

  # See if we find the library without any special options.
  # Don't add top $LIBS permanently yet
  bnv_save_LIBS="$LIBS"
  LIBS="-l$qt_direct_test_library $X_PRE_LIBS $X_LIBS -lX11 -lXext -lXmu -lXt -lXi $X_EXTRA_LIBS"
  bnv_qt_LIBS="$LIBS"
  AC_TRY_LINK([#include <$qt_direct_test_header>],
    $qt_direct_test_main,
  [
    # Succes.
    # We can link with no special library directory.
    bnv_qt_dir=
  ], [
    # That did not work.
    echo "Non-critical error, please neglect the above." >&AC_FD_CC
    # Look for the Qt dir in a standard set of common directories.
    bnv_dir_list="
      $with_Qt_dir
      /usr
      /usr/lib/qt
      /usr/lib/qt2
      /usr/lib/qt1g
      `ls -d /usr/local/qt* 2>/dev/null`
    "
    for bnv_dir in $bnv_dir_list; do
      for bnv_ext in a so sl; do
        if test -r $bnv_dir/lib/lib${qt_direct_test_library}.$bnv_ext; then
          bnv_qt_dir=$bnv_dir
          break 2
        fi
      done
    done
  ])
  QT_DIR=$bnv_qt_dir
  if test -z $bnv_qt_dir; then
    QT_LIBS=$LIBS
    # when the library is in $LD_PATH then moc can be assumed to be in $PATH:
    QT_MOC=moc
  else
    QT_LIBS="-L$bnv_qt_dir/lib $LIBS"
    QT_MOC="$bnv_qt_dir/moc"
  fi
  LIBS="$bnv_save_LIBS"
])





# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Add --enable-maintainer-mode option to configure.
# From Jim Meyering

# serial 1

AC_DEFUN(AM_MAINTAINER_MODE,
[AC_MSG_CHECKING([whether to enable maintainer-specific portions of Makefiles])
  dnl maintainer-mode is disabled by default
  AC_ARG_ENABLE(maintainer-mode,
[  --enable-maintainer-mode enable make rules and dependencies not useful
                          (and sometimes confusing) to the casual installer],
      USE_MAINTAINER_MODE=$enableval,
      USE_MAINTAINER_MODE=no)
  AC_MSG_RESULT($USE_MAINTAINER_MODE)
  AM_CONDITIONAL(MAINTAINER_MODE, test $USE_MAINTAINER_MODE = yes)
  MAINT=$MAINTAINER_MODE_TRUE
  AC_SUBST(MAINT)dnl
]
)

# Define a conditional.

AC_DEFUN(AM_CONDITIONAL,
[AC_SUBST($1_TRUE)
AC_SUBST($1_FALSE)
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

